from shutil import which
from subprocess import call
from typing import List, Dict

from skip.managers.manager import PackageManager


# TODO
class Flatpak(PackageManager):
    @classmethod
    def remove(cls, packages: Dict[str, List[str]]) -> bool:
        print(cls.canonical_name() + " packages: " + str(packages))

        installed = True
        for package, flags in packages.items():
            cmd_lst = []
            cmd_lst.extend(cls.command())
            cmd_lst.extend(["uninstall", package])
            cmd_lst.extend(flags)

            installed = installed and call(cmd_lst, stdin=True) == 0

        return installed

    @classmethod
    def setup(cls) -> bool:
        # print("You'll need to login to snapcraft in order to use it without "
        #       "sudo.")
        # print("-" * 20)
        # print("SnapCraft Login:")
        # cmd_lst: List[str] = []
        # cmd_lst.extend(cls.command())
        # cmd_lst.extend(["login"])
        #
        # return call(cmd_lst, stdin=True) == 0
        pass

    @classmethod
    def command(cls) -> List[str]:
        return "flatpak".strip().split()

    @classmethod
    def install(cls, packages: Dict[str, List[str]]) -> bool:
        print(cls.canonical_name() + " packages: " + str(packages))

        installed = True
        for package, flags in packages.items():
            cmd_lst = []
            cmd_lst.extend(cls.command())
            cmd_lst.extend(["install", package])
            cmd_lst.extend(flags)

            installed = installed and call(cmd_lst, stdin=True) == 0

        return installed

    @classmethod
    def canonical_name(cls) -> str:
        return "flatpak"

    @classmethod
    def upgrade(cls) -> bool:
        cmd_lst = []
        cmd_lst.extend(cls.command())
        cmd_lst.extend(["update"])

        return call(cmd_lst, stdin=True) == 0

    @classmethod
    def clean(cls) -> bool:
        cmd_lst = []
        cmd_lst.extend(cls.command())
        cmd_lst.extend(["repair"])

        return call(cmd_lst, stdin=True) == 0

    @classmethod
    def update(cls) -> bool:
        pass

    @classmethod
    def check(cls) -> bool:
        from skip.managers.manager import OperatingSystem
        return cls.operating_system() in {OperatingSystem.Linux} and which(
            cls.command()[0]) is not None
