from shutil import which
from subprocess import call
from typing import List, Dict

from skip.managers.manager import PackageManager


# TODO
class Gem(PackageManager):
    @classmethod
    def remove(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def command(cls) -> List[str]:
        return "gem".strip().split()

    @classmethod
    def canonical_name(cls) -> str:
        return "gem"

    @classmethod
    def upgrade(cls) -> bool:
        cmd_lst = cls.command()
        cmd_lst.extend(['update'])

        return call(cmd_lst, stdin=True) == 0

    @classmethod
    def clean(cls) -> bool:
        pass

    @classmethod
    def setup(cls):
        pass

    @classmethod
    def install(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def update(cls):
        pass

    @classmethod
    def check(cls) -> bool:
        from skip.managers.manager import OperatingSystem
        return cls.operating_system() in {OperatingSystem.Linux,
                                          OperatingSystem.MacOS} and which(
            cls.command()[0]) is not None
