from shutil import which
from subprocess import call
from typing import Dict, List

from skip.managers.manager import PackageManager


class Mas(PackageManager):

    @classmethod
    def install(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def clean(cls) -> bool:
        pass

    @classmethod
    def check(cls) -> bool:
        from skip.managers.manager import OperatingSystem
        return cls.operating_system() in {OperatingSystem.MacOS} and \
            which(cls.command()[0]) is not None

    @classmethod
    def remove(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def canonical_name(cls) -> str:
        return "mas"

    @classmethod
    def command(cls) -> List[str]:
        return "mas".strip().split()

    @classmethod
    def setup(cls) -> bool:
        # TODO setup based on OS
        pass

    @classmethod
    def update(cls) -> bool:
        pass

    @classmethod
    def upgrade(cls) -> bool:
        cmd_lst = cls.command()
        cmd_lst.extend(['upgrade'])

        return call(cmd_lst, stdin=True) == 0
