from shutil import which
from subprocess import call
from typing import List, Dict

from skip.managers.manager import OperatingSystem
from skip.managers.manager import PackageManager


# TODO
class Npm(PackageManager):
    @classmethod
    def remove(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def canonical_name(cls) -> str:
        return "npm"

    @classmethod
    def command(cls) -> List[str]:
        return "npm".strip().split()

    @classmethod
    def upgrade(cls):
        pass

    @classmethod
    def clean(cls) -> bool:
        pass

    @classmethod
    def setup(cls):
        # TODO Brew install node (therefore installing npm)
        pass

    @classmethod
    def install(cls, packages: Dict[str, List[str]]):
        print(cls.canonical_name() + " packages: " + str(packages))

        installed = True
        for package, flags in packages.items():
            cmd_lst = cls.command()
            cmd_lst.extend(["install", "-g", package])
            cmd_lst.extend(flags)

            installed = installed and call(cmd_lst, stdin=True) == 0

        return installed

    @classmethod
    def update(cls):
        cmd_lst = cls.command()
        cmd_lst.extend(['update', '-g'])

        return call(cmd_lst, stdin=True) == 0

    @classmethod
    def check(cls) -> bool:
        return cls.operating_system() in {OperatingSystem.MacOS,
                                          OperatingSystem.Linux} and \
               which(cls.command()[0]) is not None
